import { Pixel } from "./pixel";
export class Canvas {
    _width;
    _height;
    _canvas;
    constructor(width, height) {
        this._width = width;
        this._height = height;
        this._canvas = Array(width).fill(Array(height).fill(new Pixel()));
    }
    splash(node_id, offset, size, rgb) {
        if (offset[0] < 0 || this._width < offset[0])
            return;
        if (offset[1] < 0 || this._height < offset[1])
            return;
        for (let x = offset[0]; x < this._width || x < offset[0] + size[0]; x++) {
            for (let y = offset[1]; y < this._height || y < offset[1] + size[1]; y++) {
                this._canvas[x][y].paint(node_id, rgb);
            }
        }
    }
    paint(node_id, offset, rgb) {
        if (offset[0] < 0 || this._canvas.length < offset[0])
            return;
        if (offset[1] < 0 || this._canvas[offset[0]].length < offset[1])
            return;
        this._canvas[offset[0]][offset[1]].paint(node_id, rgb);
    }
    canvas() {
        return this._canvas.map((row) => row.map((pixel) => pixel.color()));
    }
    pixel(x, y) {
        return this._canvas[x][y];
    }
    merge(peer_canvas) {
        this._canvas.forEach((row, x) => row.forEach((pixel, y) => pixel.merge(peer_canvas.pixel(x, y))));
    }
}
